#include "stdafx.h"
	
//  
void RenderScene(void);
void SetupRC(void);
void ChangeSize(int, int);
	
//**********************************************************
//   
void main()
{
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(800, 600);
	glutCreateWindow("GLRect");
	glutDisplayFunc(RenderScene);
	glutReshapeFunc(ChangeSize);
	SetupRC();
	glutMainLoop();
}
	
//**********************************************************
//    
void RenderScene(void)
{
	//     
	glClear(GL_COLOR_BUFFER_BIT);
	
	//     
	//  	   R	 G	   B
	glColor3f(1.0f, 0.0f, 0.0f);
	
	//  ,   
	glRectf(-50.0f, 50.0f, 50.0f, -50.0f);
	
	//     
	glFlush();
}
	
//**********************************************************
//   
void SetupRC(void)
{
    //     
    glClearColor(0.0f, 0.0f, 1.0f, 1.0f);
}
	
//**********************************************************
//   GLUT    
void ChangeSize(int width, int height)
{
	GLfloat aspectRatio;
	
	//    
	if(height == 0)
		height = 1;
	
	//      
    glViewport(0, 0, width, height);
	
	//      
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	//    ( )
	// (left, right, bottom, top, near, far)
	aspectRatio = (GLfloat)width / (GLfloat)height;
    if (width <= height)
		glOrtho (-100.0, 100.0, -100 / aspectRatio,
				100.0 / aspectRatio, 
				1.0, -1.0);
    else 
		glOrtho (-100.0 * aspectRatio, 
				100.0 * aspectRatio, 
				-100.0, 100.0, 
				1.0, -1.0);
	
	//       
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}	
	

